## displaylink-driver 6.1

=== Makefile ===
#
# Copyright (c) 2015 - 2020 DisplayLink (UK) Ltd.
#
# This file is subject to the terms and conditions of the GNU General Public
# License v2. See the file COPYING in the main directory of this archive for
# more details.
#

EL8 := $(shell cat /etc/redhat-release 2>/dev/null | grep -c " 8." )
ifneq (,$(findstring 1, $(EL8)))
EL8FLAG := -DEL8
endif

EL9 := $(shell cat /etc/redhat-release 2>/dev/null | grep -c " 9." )
ifneq (,$(findstring 1, $(EL9)))
EL9FLAG := -DEL9
endif

Raspbian := $(shell grep -Eic 'raspb(erry|ian)' /proc/cpuinfo /etc/os-release 2>/dev/null )
ifeq (,$(findstring 0, $(Raspbian)))
RPIFLAG := -DRPI
endif

ifneq ($(DKMS_BUILD),)

# DKMS

KERN_DIR := /lib/modules/$(KERNELRELEASE)/build

ccflags-y := -Iinclude/uapi/drm -Iinclude/drm $(EL8FLAG) $(EL9FLAG) $(RPIFLAG)
evdi-y := evdi_platform_drv.o evdi_platform_dev.o evdi_sysfs.o evdi_modeset.o evdi_connector.o evdi_encoder.o evdi_drm_drv.o evdi_fb.o evdi_gem.o evdi_painter.o evdi_params.o evdi_cursor.o evdi_debug.o evdi_i2c.o
evdi-$(CONFIG_COMPAT) += evdi_ioc32.o
obj-m := evdi.o

KBUILD_VERBOSE ?= 1

all:
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) M=$(CURDIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) CONFIG_MODULE_SIG= -C $(KERN_DIR) modules

clean:
	@echo $(KERN_DIR)
	$(MAKE) KBUILD_VERBOSE=$(KBUILD_VERBOSE) M=$(CURDIR) SUBDIRS=$(CURDIR) SRCROOT=$(CURDIR) -C $(KERN_DIR) clean

else

# Not DKMS

ifneq ($(KERNELRELEASE),)

# inside kbuild
# Note: this can be removed once it is in kernel tree and Kconfig is properly used
ccflags-y := -isystem include/uapi/drm $(CFLAGS) $(EL8FLAG) $(EL9FLAG) $(RPIFLAG)
evdi-y := evdi_platform_drv.o evdi_platform_dev.o evdi_sysfs.o evdi_modeset.o evdi_connector.o evdi_encoder.o evdi_drm_drv.o evdi_fb.o evdi_gem.o evdi_painter.o evdi_params.o evdi_cursor.o evdi_debug.o evdi_i2c.o
evdi-$(CONFIG_COMPAT) += evdi_ioc32.o
CONFIG_DRM_EVDI ?= m
obj-$(CONFIG_DRM_EVDI) := evdi.o
obj-y += tests/

else

# kbuild against specified or current kernel
CP ?= cp
DKMS ?= dkms
RM ?= rm

MODVER=1.14.7

ifeq ($(KVER),)
	KVER := $(shell uname -r)
endif

ifneq ($(RUN_DEPMOD),)
	DEPMOD := /sbin/depmod -a
else
	DEPMOD := true
endif

ifeq ($(KDIR),)
	KDIR := /lib/modules/$(KVER)/build
endif

MOD_KERNEL_PATH := /kernel/drivers/gpu/drm/evdi

default: module

module:
	$(MAKE) -C $(KDIR) M=$$PWD

clean:
	$(RM) -rf *.o *.a *.ko .tmp* .*.*.cmd Module.symvers evdi.mod.c modules.order

install:
	$(MAKE) -C $(KDIR) M=$$PWD INSTALL_MOD_PATH=$(DESTDIR) INSTALL_MOD_DIR=$(MOD_KERNEL_PATH) modules_install
	$(DEPMOD)

uninstall:
	$(RM) -rf $(DESTDIR)/lib/modules/$(KVER)/$(MOD_KERNEL_PATH)
	$(DEPMOD)

install_dkms:
	$(DKMS) install .

uninstall_dkms:
	$(DKMS) remove evdi/$(MODVER) --all
	$(RM) -rf /usr/src/evdi-$(MODVER)

endif # ifneq ($(KERNELRELEASE),)

endif # ifneq ($(DKMS_BUILD),)

=== debian/changelog ===
displaylink-driver (6.1-2) unstable; urgency=medium

  * debian/control: change to Rules-Requires-Root: binary-targets
    (Closes: #1102721)
    Thanks a lot to Santiago Vila for the info.

 -- Thorsten Alteholz <debian@alteholz.de>  Sat, 12 Apr 2025 19:20:27 +0200

displaylink-driver (6.1-1) unstable; urgency=medium

  * initial version

 -- Thorsten Alteholz <debian@alteholz.de>  Wed, 09 Apr 2025 22:20:27 +0200

=== debian/control ===
Source: displaylink-driver
Section: non-free/x11
Priority: optional
Maintainer: Thorsten Alteholz <debian@alteholz.de>
Build-Depends: debhelper-compat (= 13)
	, linux-headers-amd64
	, linux-source
	, libdrm-dev
	, libelf-dev
	, x11-xserver-utils
	, pciutils
	, dkms
	, pkg-config
	, mokutil
	, libusb-1.0-0-dev
Standards-Version: 4.7.2
Homepage: https://www.synaptics.com/products/displaylink-graphics/downloads
Rules-Requires-Root: binary-targets
Vcs-Browser: https://salsa.debian.org/alteholz/displaylink-driver
Vcs-Git: https://salsa.debian.org/alteholz/displaylink-driver.git

Package: displaylink-driver
Architecture: amd64
Depends: ${shlibs:Depends}, ${misc:Depends}, evdi-dkms, libusb-1.0-0
Description: DisplayLink - The Ultimate Virtual Graphics Card
 DisplayLink software is more than just a graphics driver; it functions
 as a virtual graphics card that works seamlessly with the operating system,
 overcoming the limitations of the host platform and enabling the connection
 of multiple displays. By installing DisplayLink, users can extend their
 screen real estate without the need for additional physical graphics cards,
 allowing for enhanced productivity and multitasking.
 .
 For added security and to ensure the best interoperability, all DisplayLink
 software updates the SoC firmware to guarantee interoperability and ensure
 the very best user experience.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

export SYSTEMINITDAEMON=systemd

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

%:
	dh $@

override_dh_auto_install:
	cd displaylink-driver-6.1.0; pwd; ./displaylink-installer.sh
	echo "##########################################################"
	find

=== debian/watch ===
version=4

# a watch file is not possible
# run getDriver to get the latest version
